#include <iostream>
#include <string>
#include <algorithm>
#include <cstdio>
#include <cmath>
#include <vector>

using namespace std;

const int INF = 1000000001;

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    int n, m;
    cin >> n >> m;
    int dx[4] = {0, 0, -1, 1}, dy[4] = {1, -1, 0, 0};
    vector<vector<int> > d(n + 2, vector<int>(m + 2, INF)), u(n + 2, vector<int>(m + 2, 0));
    vector<vector<vector<pair<int, int> > > > s(n + 2, vector<vector<pair<int, int> > >(m + 2));

    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= m; j++) {
            int c; cin >> c;
            s[i][j].resize(c);
            for (int k = 0; k < c; k++) cin >> s[i][j][k].first >> s[i][j][k].second;
        }

    d[1][1] = 0;

    for (int i = 0; i < n * m; i++) {
        pair<int, int> v(-1, -1);            

        for (int j = 1; j <= n; j++)
            for (int k = 1; k <= m; k++)
                if (!u[j][k] && (v.first == -1 || d[j][k] < d[v.first][v.second]))
                    v.first = j, v.second = k;

        if (d[v.first][v.second] == INF) break;

        u[v.first][v.second] = 1;

        for (int j = 0; j < 4; j++) {
            pair<int, int> to(v.first + dx[j], v.second + dy[j]);
            int time = d[v.first][v.second];
            bool check = false;
            for (int k = 0; k < s[v.first][v.second].size(); k++)
                if (time >= s[v.first][v.second][k].first && time <= s[v.first][v.second][k].second)
                    time += s[v.first][v.second][k].second - time;

            d[to.first][to.second] = min(d[to.first][to.second], time);
        }
    }

    cout << d[n][m];
}